HOOGLE(1)

NAME
hoogle - A Haskell API search engine.

SYNOPSIS
hoogle EXPRESSION|COMMAND [OPTIONS]

DESCRIPTION
Hoogle is a Haskell API search engine which allows you to search Haskell libraries by either function name, or by approximate type signature.
Example searches with EXPRESSION:
        map
        (a -> b) -> [a] -> [b]
        Ord a => [a] -> [a]
        Data.Map.insert
The Hoogle manual (http://www.haskell.org/haskellwiki/Hoogle) contains more details, including further details on search queries, how to install Hoogle as a command line application and how to integrate Hoogle with Firefox/Emacs/Vim etc.

This program also has some command for special usage.

  Command reference:

search
    Perform a search

generate
    Generate Hoogle databases

server
    Start a Hoogle server

replay
    Replay a log file

test
    Run the test suite

  Common options:

-?, --help
    Display help message

-V,--version
    Print version information

--numeric-version
    Print just the version number

-v, --verbose
    Loud verbosity

-q, --quiet
    Quiet verbosity

  Search command options:

--color, --colour
    Use colored output (requires ANSI terminal)

--json
    Get result as JSON

--jsonl
    Get result as JSONL (JSON Lines)

-l, --link
    Give URL's for each result

--numbers
    Give counter for each result

-i, --info
    Give extended information about the first result

-d, --database=FILE
    Name of database to use (use .hoo extension)

-n, --count=INT
    Maximum number of results to return (defaults to 10)

-r, --repeat=INT
    Number of times to repeat (for benchmarking)

--compare=ITEM
    Type signatures to compare against

  Generate command options:

--download
    Download all files from the web

--database=FILE
    Name of database to use (use .hoo extension)

-i, --insecure
    Allow insecure HTTPS connections

-n, --count=INT
    Maximum number of packages to index (defaults to all)

-l, --local[=ITEM]
    Index local packages and link to local haddock docs

-h, --haddock=ITEM
    Use local haddocks

--debug
    Generate debug information

  Server command options:

-p, --port=INT
    Port number

--database=FILE
    Name of database to use (use .hoo extension)

--cdn=URL
    URL prefix to use

--logs[=FILE]
    File to log requests to (defaults to stdout)

--local
    Allow following file:// links, restricts to 127.0.0.1. Set --host explicitly (including to '*' for any host) to override the localhost-only behavior.

--haddock=ITEM
    Serve local haddocks from a specified directory

--links
    Display extra links

-s, --scope=ITEM
    Default scope to start with

--home=URL
    Set the URL linked to by the Hoogle logo.

--host=ITEM
    Set the host to bind on (e.g., an ip address; '!4' for ipv4-only; '!6' for ipv6-only; default: '*' for any host).

--https
    Start an https server (use --cert and --key to specify paths to the .pem files)

--cert=FILE
    Path to the certificate pem file (when running an https server)

-k, --key
    Path to the key pem file (when running an https server)

--datadir=ITEM
    Override data dirctory paths

-n, --no-security-headers
    Don't send CSP security headers

  Replay command options:

--database=FILE
    Name of database to use (use .hoo extension)

-r, --repeat=INT
    Number of times to repeat (for benchmarking)

-s, --scope=ITEM
    Default scope to start with

  Test command options:

--deep
    Run extra long tests

--disable-network-tests
    Disables the use of network tests

--database=FILE
    Name of database to use (use .hoo extension)

AUTHOR
The text for this page was constructed from the Hoogle search engine's web page and written by Erik de Castro Lopo <erikd@mega-nerd.com> and Kiwamu Okabe <kiwamu@debian.or.jp>, for the Debian GNU/Linux system (but may be used by others).

SEE ALSO

haddock(1), update-hoogle(8)